///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version: 1.5
// \ \ Application : MIG
// / / Filename: addr_gen.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name: addr_gen.v
//Description : It generates address and burst done signal for the test bench.
///////////////////////////////////////////////////////////////////////////////

`include "D:\\sajat\\xst_vlog_bl2cl2_parameters_0.v"

`timescale 1ns/100ps

module xst_vlog_bl2cl2_addr_gen_0(
                clk,
	        rst,
	        addr_rst,  
	        addr_inc, 
	        addr_out,  
	        test_cnt_ena,  
	        burst_done,  
	        cnt_roll 
                );

   input        clk;               
   input        rst;
   input        addr_rst;
   input        addr_inc;
   input        test_cnt_ena;
   
//   output [((`row_address + `column_address + `bank_address)-1):0] addr_out;
     output [((`row_address + `col_ap_width + `bank_address)-1):0] addr_out;
      
   output       burst_done;
   output       cnt_roll;
   
   reg          cnt_roll;
   reg [7:0]    column_counter;
   reg [1:0]    cnt;
   reg          burst_done_reg;
   reg          burst_done_1_reg;

   reg          cnt_roll_p;
   reg          cnt_roll_p2;
   
   wire [`bank_address-1:0]   ba_count;


   
assign ba_count       = {{`bank_address-1{1'b0}},1'b0}; 
//assign addr_out       = {{`row_address-2{1'b0}},2'b10,{`column_address-8{1'b0}},column_counter, ba_count};
  assign addr_out       = {{`row_address-2{1'b0}},2'b10,{`col_ap_width -8{1'b0}},column_counter, ba_count};

//assign burst_done     = burst_done_1_reg;

assign burst_done     = burst_done_1_reg;





always @ (posedge clk)
begin
   if (rst == 1'b1 || addr_rst == 1'b1)
     begin
        column_counter <= 8'b0;
        cnt <= 2'b0;
     end

       else if ((addr_inc == 1'b1) && (cnt == 2'b00))
     cnt <= 2'b01;
    else if ((addr_inc == 1'b1) && (cnt == 2'b01)) 
          begin
           if (column_counter == 8'b00001000)      //8'b00010000)
              begin
               column_counter <= 8'b0;
              end
           else if( cnt_roll == 1'b0) 
               column_counter <= column_counter + 4'h2;
          end
        else 
            column_counter <= column_counter;
     end





  /* else if (addr_inc == 1'b1)
     begin
 //       if (cnt == 2'b01)
//        if (cnt == 2'b11)   BL = 8
          if (cnt == burst_cnt)  // Modified by Abhishake For BL = 8,4
          cnt <= 2'b0;
        else
          cnt <= cnt + 1'b1;
//        if ((test_cnt_ena == 1'b1) && (cnt == 2'b01))
//        if ((test_cnt_ena == 1'b1) && (cnt == 2'b11))      //Modified By Abhishake For BL = 8
          if ((test_cnt_ena == 1'b1) && (cnt == burst_cnt))  //Modified By Abhishake For BL = 8,4
          begin
//           if (column_counter == 8'b00010000)
//           if (column_counter == 8'b00100000)               //Modified By Abhishake For BL = 8
             if (column_counter == {2'b00,burst_cnt,4'b0000})  //Modified By Abhishake For BL = 8,4
              column_counter <= 8'b0;
           else 
//                column_counter <= column_counter + 4'h4;  
//                column_counter <= column_counter + 4'h8;     // For BL = 8 
                  column_counter <= column_counter + col_inc ; // For BL = 8,4 
          end
        else 
            column_counter <= column_counter;
     end
end
*/

/*always @ (posedge clk)
begin
 if(burst_cnt == 2'b01)
  burst_done_reg <= (!rst && column_counter[4]);
 else if(burst_cnt == 2'b11)
  burst_done_reg <= (!rst && column_counter[5]);   //Modified By Abhishake For BL = 8
end
*/

always @ (posedge clk)
begin

   burst_done_reg <= (!rst && column_counter[1] && column_counter[2]);  



end

always @ (posedge clk)
begin
 burst_done_1_reg <= (!rst && burst_done_reg );
end



/*always @ (posedge clk)
begin
 if(burst_cnt == 2'b01)
 cnt_roll_p <= (!rst && column_counter[3] && column_counter[2] && !column_counter[1] && !column_counter[0]); //BL = 4
else  if(burst_cnt == 2'b11)
 cnt_roll_p <= (!rst && column_counter[4] && column_counter[3] && !column_counter[2] && !column_counter[1] && !column_counter[0]); // BL = 8
end
*/

always @ (posedge clk)
begin

      cnt_roll_p <= (!rst && column_counter[2] && !column_counter[1] && !column_counter[0]);          //For BL = 2




end


always @ (posedge clk)
begin
  if (rst == 1'b1)
    begin
     cnt_roll_p2 <= 1'b0;
     cnt_roll    <= 1'b0;
    end
  else
    begin
     cnt_roll_p2  <= cnt_roll_p;
     cnt_roll     <= cnt_roll_p2;
    end
end

/*

// To TEST SIngle BUSRT
always @ (posedge clk)
begin
  if (rst == 1'b1)
     cnt_roll_p <= 1'b0;
  else
  begin   
     if(addr_inc == 1'b1)
     begin
//        cnt_roll_p <= 1'b1;
        cnt_roll <= 1'b1;
     end  
     else
     begin
//       cnt_roll_p <= 1'b0;
        cnt_roll <= 1'b0;
     end  
//     cnt_roll   <= cnt_roll_p;
  end   
end


always @ (posedge clk)
begin
  if (rst == 1'b1)
    begin
     burst_done_reg   <= 1'b0;
     burst_done_1_reg <= 1'b0;
    // column_counter <= 4'd4;
    end
   else if (addr_inc == 1'b1)
    begin
     burst_done_reg <= 1'b1;
     burst_done_1_reg <= burst_done_reg;
    end
  else
    begin
     burst_done_reg <= 1'b0;
     burst_done_1_reg <= burst_done_reg;
    end
end
*/


endmodule   
