///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// All Rights Reserved
///////////////////////////////////////////////////////////////////////////////
// ____ ____
// / /\/ /
// /___/ \ / Vendor: Xilinx
// \ \ \/ Version  : 1.5
// \ \ Application : MIG
// / / Filename    : lfsr32.v
// /___/ /\ 
// \ \ / \
// \___\/\___\
//
//Design Name : lfsr32.v
//Description : This module generates the user input data for hardware test 
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/100ps

`include "D:\\sajat\\xst_vlog_bl2cl2_parameters_0.v"

module    xst_vlog_bl2cl2_lfsr32_0( 
		clk,
		rst,
		lfsr_rst,
		lfsr_ena,
		lfsr_data_m,
		lfsr_out
                );
               
   input          clk;
   input          rst;
   input          lfsr_rst;
   input          lfsr_ena;   

   output [((`data_mask_width*2)-1):0]	lfsr_data_m;
   output [((`data_width*2)-1):0] lfsr_out;
   
   reg  [7:0]    lfsr_r;
   reg  [7:0]    lfsr_f;
   
assign lfsr_data_m = 16'b0;


           
assign lfsr_out = {
	lfsr_r,
	lfsr_r ,
                   
	lfsr_f,
	lfsr_f
		   };                          

always @ (posedge clk)
begin
	if (rst == 1'b1)
	begin
		lfsr_r <= 'b0;
		lfsr_f <= 'd1;
	end
	else if (lfsr_rst == 1'b1)
		begin
		lfsr_r <= 'b0;
		lfsr_f <= 'd1;
		end
	else if (lfsr_ena == 1'b1)
	begin
		lfsr_r <= lfsr_r + 2;	
		lfsr_f <= lfsr_f + 2;	
	end
	else
	begin
		lfsr_f <= lfsr_f ;
		lfsr_r <= lfsr_r;
	end
	end

endmodule
