library verilog;
use verilog.vl_types.all;
entity xst_vlog_bl2cl2_controller_0 is
    generic(
        IDLE            : integer := 0;
        PRECHARGE       : integer := 1;
        LOAD_MODE_REG   : integer := 2;
        AUTO_REFRESH    : integer := 3;
        ACTIVE          : integer := 4;
        FIRST_WRITE     : integer := 5;
        WRITE_WAIT      : integer := 6;
        BURST_WRITE     : integer := 7;
        READ_AFTER_WRITE: integer := 8;
        PRECHARGE_AFTER_WRITE: integer := 9;
        PRECHARGE_AFTER_WRITE_2: integer := 10;
        READ_WAIT       : integer := 11;
        BURST_READ      : integer := 12;
        BURST_STOP      : integer := 13;
        ACTIVE_WAIT     : integer := 14
    );
    port(
        clk             : in     vl_logic;
        rst0            : in     vl_logic;
        rst180          : in     vl_logic;
        address         : in     vl_logic_vector(23 downto 0);
        bank_address    : in     vl_logic_vector(1 downto 0);
        config_register : in     vl_logic_vector(9 downto 0);
        command_register: in     vl_logic_vector(2 downto 0);
        burst_done      : in     vl_logic;
        ddr_rasb_cntrl  : out    vl_logic;
        ddr_casb_cntrl  : out    vl_logic;
        ddr_web_cntrl   : out    vl_logic;
        ddr_ba_cntrl    : out    vl_logic_vector(1 downto 0);
        ddr_address_cntrl: out    vl_logic_vector(12 downto 0);
        ddr_cke_cntrl   : out    vl_logic;
        ddr_csb_cntrl   : out    vl_logic;
        dqs_enable      : out    vl_logic;
        dqs_reset       : out    vl_logic;
        write_enable    : out    vl_logic;
        rst_calib       : out    vl_logic;
        rst_dqs_div_int : out    vl_logic;
        cmd_ack         : out    vl_logic;
        init            : out    vl_logic;
        ar_done         : out    vl_logic;
        wait_200us      : in     vl_logic;
        auto_ref_req    : out    vl_logic
    );
end xst_vlog_bl2cl2_controller_0;
