//DDR SDRAM common interface testing
//CPU emulator for terting

// Company: Quenne Electric
// Engineer: Andras Bognar

`timescale 1ps / 1ps

module cpuemu(
//Interface signals to the HOST
	CLK,	//clock input 50MHz
	ADDR,	//address bus
	DATAIN,	//data bus
	DATAOUT,//data bus
	W,		//command: write, not read
	READY,	//execution status
	STR,	//strobe for command
	LED1,
	LED2
	);

//HOST IF
	input CLK;				//50MHz clock will be multiplied by 4
	output [23:0]ADDR;		//16M x32  (24 bit)
	output [31:0]DATAIN;
	input[31:0]DATAOUT;
	output W;
	input READY;
	output STR;
	output LED1;			//show if test1 is ok
	output LED2;			//show if test2 is ok
//Internal registers
	//output registers
	reg [23:0]addr=0;
	reg [31:0]data=0;
	reg w=0;
	reg str=0;
	//state registers
	reg [3:0]state=0;
	reg led1=0;
	reg led2=0;
		
	always@(posedge CLK)
		begin
		case(state)
//INIT		
		4'h0:
			begin
			w<=0;
			str<=0;
			state<=4'h1;
			led1<=0;
			led2<=0;
			end
//TEST1
		4'h1:
			begin
			addr[23:0]<=24'h000055;
			data[31:0]<=32'h54545454;
			state<=4'h2;
			end
		4'h2:
			begin
			str<=1;
			w<=1;
			state<=4'h3;
			end
		4'h3:
			begin
			if(READY==1) state<=4'h4;
			end
		4'h4:
			begin
			w<=0;
			str<=0;
			if(READY==0)state<=4'h5;
			end
		4'h5:
			begin
			str<=1;
			state<=4'h6;
			end
		4'h6:
			begin
			if(READY==1) 
				begin
				state<=4'h7;
				if(DATAOUT==data)led1<=1;
				end
			end
		4'h7:
			begin
			str<=0;
			if(READY==0) state<=4'h8;
			end
//TEST2			
		4'h8:
			begin
			addr[23:0]<=24'h32863A;
			data[31:0]<=32'h567ABC1F;
			state<=4'h9;
			end
		4'h9:
			begin
			str<=1;
			w<=1;
			state<=4'hA;
			end
		4'hA:
			begin
			if(READY==1) state<=4'hB;
			end
		4'hB:
			begin
			w<=0;
			str<=0;
			if(READY==0)state<=4'hC;
			end
		4'hC:
			begin
			str<=1;
			state<=4'hD;
			end
		4'hD:
			begin
			if(READY==1) 
				begin
				state<=4'hE;
				if(DATAOUT==data)led2<=1;
				end
			end
		4'hE:
			begin
			str<=0;
			if(READY==0) state<=4'hF;
			end
//end
		4'hF:
			begin
			end
		default:state<=4'h0;
		endcase
		end
	
	assign ADDR=addr;
	assign DATAIN=data;
	assign W=w;
	assign STR=str;
	assign LED1=led1;
	assign LED2=led2;
		
endmodule
